from typing import Optional


class TreeNode:
    def __init__(self, val=0, left=None, right=None):
        self.val = val
        self.left = left
        self.right = right


class Solution:
    def searchBST(self, root: Optional[TreeNode], val: int) -> Optional[TreeNode]:
        if not root:
            return None

        if val < root.val:
            return self.searchBST(root.left, val)
        elif val > root.val:
            return self.searchBST(root.right, val)
        else:
            return root


if __name__ == "__main__":
    s = Solution()
    n10 = TreeNode(1, None, None)
    n9 = TreeNode(3, None, None)
    n8 = TreeNode(2, n10, n9)
    n7 = TreeNode(7, None, None)
    root = TreeNode(4, n8, n7)

    print(s.searchBST(root, 2).val)
