Merge Two Sorted Linked Lists
You are given the heads of two sorted linked lists list1 and list2.

Merge the two lists into one sorted linked list and return the head of the new sorted linked list.

The new list should be made up of nodes from list1 and list2.

Example 1:



Input: list1 = [1,2,4], list2 = [1,3,5]

Output: [1,1,2,3,4,5]
Example 2:

Input: list1 = [], list2 = [1,2]

Output: [1,2]
Example 3:

Input: list1 = [], list2 = []

Output: []
Constraints:

0 <= The length of the each list <= 100.
-100 <= Node.val <= 100

# Solution

## Edge cases
### Two empty
l1 = []
l2 = []

r = None
### l1 empty
l1 = []
l2 = [1,2,...,n]

r = l2
### l2 empty
l1 = [1,2,...,n]
l2 = []

r = l1

## Algorithm
### 0
      i     
l1 = [1,2,4]

      j     
l2 = [1,3,5]

r = []

### 1
Before: 

      i     
l1 = [1,2,4]

      j     
l2 = [1,3,5]

r = []

Step:
```
if i.val <= j.val:
    r = i
    i = i.next
```

After:

        i   
l1 = [1,2,4]

      j     
l2 = [1,3,5]

r = [l10]

### 2
Before:
        i   
l1 = [1,2,4]

      j     
l2 = [1,3,5]

r = [l10]

Step:
```
if i.val <= j.val:
    ---
else:
    r.next = j
    j = j.next
    r = r.next
```
After:
        i   
l1 = [1,2,4]

        j  
l2 = [1,3,5]

r = [l10, l20]

### 3
Before:
        i   
l1 = [1,2,4]

        j  
l2 = [1,3,5]

r = [l10, l20]

Step:
```
if i.val <= j.val:
    r.next = i
    i = i.next
    r = r.next
else:
    r.next = j
    j = j.next
    r = r.next
```
After:
          j
l1 = [1,2,4]

        j  
l2 = [1,3,5]

r = [l10, l20, l11]
